diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/three-gpp-http-client.cc ns-3.44/src/applications/model/three-gpp-http-client.cc
--- ns-3.43/src/applications/model/three-gpp-http-client.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/three-gpp-http-client.cc	2025-03-09 16:55:49.347370900 -0700
@@ -11,17 +11,16 @@
 
 #include "three-gpp-http-variables.h"
 
-#include <ns3/callback.h>
-#include <ns3/double.h>
-#include <ns3/inet-socket-address.h>
-#include <ns3/inet6-socket-address.h>
-#include <ns3/log.h>
-#include <ns3/packet.h>
-#include <ns3/pointer.h>
-#include <ns3/simulator.h>
-#include <ns3/socket.h>
-#include <ns3/tcp-socket-factory.h>
-#include <ns3/uinteger.h>
+#include "ns3/address-utils.h"
+#include "ns3/callback.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/packet.h"
+#include "ns3/pointer.h"
+#include "ns3/simulator.h"
+#include "ns3/socket.h"
+#include "ns3/tcp-socket-factory.h"
+#include "ns3/uinteger.h"
 
 NS_LOG_COMPONENT_DEFINE("ThreeGppHttpClient");
 
@@ -31,16 +30,17 @@
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppHttpClient);
 
 ThreeGppHttpClient::ThreeGppHttpClient()
-    : m_state(NOT_STARTED),
-      m_socket(nullptr),
-      m_objectBytesToBeReceived(0),
-      m_objectClientTs(MilliSeconds(0)),
-      m_objectServerTs(MilliSeconds(0)),
-      m_embeddedObjectsToBeRequested(0),
-      m_pageLoadStartTs(MilliSeconds(0)),
-      m_numberEmbeddedObjectsRequested(0),
-      m_numberBytesPage(0),
-      m_httpVariables(CreateObject<ThreeGppHttpVariables>())
+    : m_state{NOT_STARTED},
+      m_socket{nullptr},
+      m_objectBytesToBeReceived{0},
+      m_objectClientTs{},
+      m_objectServerTs{},
+      m_embeddedObjectsToBeRequested{0},
+      m_pageLoadStartTs{},
+      m_numberEmbeddedObjectsRequested{0},
+      m_numberBytesPage{0},
+      m_httpVariables{CreateObject<ThreeGppHttpVariables>()},
+      m_peerPort{}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -51,7 +51,7 @@
 {
     static TypeId tid =
         TypeId("ns3::ThreeGppHttpClient")
-            .SetParent<Application>()
+            .SetParent<SourceApplication>()
             .AddConstructor<ThreeGppHttpClient>()
             .AddAttribute(
                 "Variables",
@@ -62,19 +62,17 @@
             .AddAttribute("RemoteServerAddress",
                           "The address of the destination server.",
                           AddressValue(),
-                          MakeAddressAccessor(&ThreeGppHttpClient::m_remoteServerAddress),
-                          MakeAddressChecker())
+                          MakeAddressAccessor(&ThreeGppHttpClient::SetRemote),
+                          MakeAddressChecker(),
+                          TypeId::SupportLevel::DEPRECATED,
+                          "Replaced by Remote in ns-3.44.")
             .AddAttribute("RemoteServerPort",
                           "The destination port of the outbound packets.",
                           UintegerValue(80), // the default HTTP port
-                          MakeUintegerAccessor(&ThreeGppHttpClient::m_remoteServerPort),
-                          MakeUintegerChecker<uint16_t>())
-            .AddAttribute("Tos",
-                          "The Type of Service used to send packets. "
-                          "All 8 bits of the TOS byte are set (including ECN bits).",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&ThreeGppHttpClient::m_tos),
-                          MakeUintegerChecker<uint8_t>())
+                          MakeUintegerAccessor(&ThreeGppHttpClient::SetPort),
+                          MakeUintegerChecker<uint16_t>(),
+                          TypeId::SupportLevel::DEPRECATED,
+                          "Replaced by Remote in ns-3.44.")
             .AddTraceSource("RxPage",
                             "A page has been received.",
                             MakeTraceSourceAccessor(&ThreeGppHttpClient::m_rxPageTrace),
@@ -139,6 +137,36 @@
     return tid;
 }
 
+void
+ThreeGppHttpClient::SetRemote(const Address& addr)
+{
+    NS_LOG_FUNCTION(this << addr);
+    if (!addr.IsInvalid())
+    {
+        m_peer = addr;
+        if (m_peerPort)
+        {
+            SetPort(*m_peerPort);
+        }
+    }
+}
+
+void
+ThreeGppHttpClient::SetPort(uint16_t port)
+{
+    NS_LOG_FUNCTION(this << port);
+    if (m_peer.IsInvalid())
+    {
+        // save for later
+        m_peerPort = port;
+        return;
+    }
+    if (Ipv4Address::IsMatchingType(m_peer) || Ipv6Address::IsMatchingType(m_peer))
+    {
+        m_peer = addressUtils::ConvertToSocketAddress(m_peer, port);
+    }
+}
+
 Ptr<Socket>
 ThreeGppHttpClient::GetSocket() const
 {
@@ -230,19 +258,16 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    if (m_state == CONNECTING)
-    {
-        NS_ASSERT_MSG(m_socket == socket, "Invalid socket.");
-        m_connectionEstablishedTrace(this);
-        socket->SetRecvCallback(MakeCallback(&ThreeGppHttpClient::ReceivedDataCallback, this));
-        NS_ASSERT(m_embeddedObjectsToBeRequested == 0);
-        m_eventRequestMainObject =
-            Simulator::ScheduleNow(&ThreeGppHttpClient::RequestMainObject, this);
-    }
-    else
+    if (m_state != CONNECTING)
     {
         NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ConnectionSucceeded().");
     }
+
+    NS_ASSERT_MSG(m_socket == socket, "Invalid socket.");
+    m_connectionEstablishedTrace(this);
+    socket->SetRecvCallback(MakeCallback(&ThreeGppHttpClient::ReceivedDataCallback, this));
+    NS_ASSERT(m_embeddedObjectsToBeRequested == 0);
+    m_eventRequestMainObject = Simulator::ScheduleNow(&ThreeGppHttpClient::RequestMainObject, this);
 }
 
 void
@@ -252,9 +277,7 @@
 
     if (m_state == CONNECTING)
     {
-        NS_LOG_ERROR("Client failed to connect"
-                     << " to remote address " << m_remoteServerAddress << " port "
-                     << m_remoteServerPort << ".");
+        NS_LOG_ERROR("Client failed to connect to remote address " << m_peer);
     }
     else
     {
@@ -301,10 +324,8 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    Ptr<Packet> packet;
     Address from;
-
-    while ((packet = socket->RecvFrom(from)))
+    while (auto packet = socket->RecvFrom(from))
     {
         if (packet->GetSize() == 0)
         {
@@ -353,65 +374,67 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == NOT_STARTED || m_state == EXPECTING_EMBEDDED_OBJECT ||
-        m_state == PARSING_MAIN_OBJECT || m_state == READING)
+    if (m_state != NOT_STARTED && m_state != EXPECTING_EMBEDDED_OBJECT &&
+        m_state != PARSING_MAIN_OBJECT && m_state != READING)
     {
-        m_socket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
-        NS_ABORT_MSG_IF(m_remoteServerAddress.IsInvalid(),
-                        "'RemoteServerAddress' attribute not properly set");
-        if (Ipv4Address::IsMatchingType(m_remoteServerAddress))
-        {
-            int ret [[maybe_unused]];
-
-            ret = m_socket->Bind();
-            NS_LOG_DEBUG(this << " Bind() return value= " << ret
-                              << " GetErrNo= " << m_socket->GetErrno() << ".");
-
-            Ipv4Address ipv4 = Ipv4Address::ConvertFrom(m_remoteServerAddress);
-            InetSocketAddress inetSocket = InetSocketAddress(ipv4, m_remoteServerPort);
-            NS_LOG_INFO(this << " Connecting to " << ipv4 << " port " << m_remoteServerPort << " / "
-                             << inetSocket << ".");
-            m_socket->SetIpTos(m_tos);
-            ret = m_socket->Connect(inetSocket);
-            NS_LOG_DEBUG(this << " Connect() return value= " << ret
-                              << " GetErrNo= " << m_socket->GetErrno() << ".");
-        }
-        else if (Ipv6Address::IsMatchingType(m_remoteServerAddress))
-        {
-            int ret [[maybe_unused]];
-
-            ret = m_socket->Bind6();
-            NS_LOG_DEBUG(this << " Bind6() return value= " << ret
-                              << " GetErrNo= " << m_socket->GetErrno() << ".");
-
-            Ipv6Address ipv6 = Ipv6Address::ConvertFrom(m_remoteServerAddress);
-            Inet6SocketAddress inet6Socket = Inet6SocketAddress(ipv6, m_remoteServerPort);
-            NS_LOG_INFO(this << " connecting to " << ipv6 << " port " << m_remoteServerPort << " / "
-                             << inet6Socket << ".");
-            ret = m_socket->Connect(inet6Socket);
-            NS_LOG_DEBUG(this << " Connect() return value= " << ret
-                              << " GetErrNo= " << m_socket->GetErrno() << ".");
-        }
-
-        NS_ASSERT_MSG(m_socket, "Failed creating socket.");
-
-        SwitchToState(CONNECTING);
-
-        m_socket->SetConnectCallback(
-            MakeCallback(&ThreeGppHttpClient::ConnectionSucceededCallback, this),
-            MakeCallback(&ThreeGppHttpClient::ConnectionFailedCallback, this));
-        m_socket->SetCloseCallbacks(MakeCallback(&ThreeGppHttpClient::NormalCloseCallback, this),
-                                    MakeCallback(&ThreeGppHttpClient::ErrorCloseCallback, this));
-        m_socket->SetRecvCallback(MakeCallback(&ThreeGppHttpClient::ReceivedDataCallback, this));
-        m_socket->SetAttribute("MaxSegLifetime", DoubleValue(0.02)); // 20 ms.
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for OpenConnection().");
+    }
 
-    } // end of `if (m_state == {NOT_STARTED, EXPECTING_EMBEDDED_OBJECT, PARSING_MAIN_OBJECT,
-      // READING})`
+    m_socket = Socket::CreateSocket(GetNode(), TcpSocketFactory::GetTypeId());
+    NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
+    if (!m_local.IsInvalid())
+    {
+        NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
+                         InetSocketAddress::IsMatchingType(m_local)) ||
+                            (InetSocketAddress::IsMatchingType(m_peer) &&
+                             Inet6SocketAddress::IsMatchingType(m_local)),
+                        "Incompatible peer and local address IP version");
+    }
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        const auto ret [[maybe_unused]] =
+            m_local.IsInvalid() ? m_socket->Bind() : m_socket->Bind(m_local);
+        NS_LOG_DEBUG(this << " Bind() return value= " << ret
+                          << " GetErrNo= " << m_socket->GetErrno() << ".");
+
+        const auto ipv4 = InetSocketAddress::ConvertFrom(m_peer).GetIpv4();
+        const auto port = InetSocketAddress::ConvertFrom(m_peer).GetPort();
+        NS_LOG_INFO(this << " Connecting to " << ipv4 << " port " << port << " / " << m_peer
+                         << ".");
+        m_socket->SetIpTos(m_tos);
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        const auto ret [[maybe_unused]] =
+            m_local.IsInvalid() ? m_socket->Bind6() : m_socket->Bind(m_local);
+        NS_LOG_DEBUG(this << " Bind6() return value= " << ret
+                          << " GetErrNo= " << m_socket->GetErrno() << ".");
+
+        const auto ipv6 = Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6();
+        const auto port = Inet6SocketAddress::ConvertFrom(m_peer).GetPort();
+        NS_LOG_INFO(this << " Connecting to " << ipv6 << " port " << port << " / " << m_peer
+                         << ".");
+    }
     else
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for OpenConnection().");
+        NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
     }
 
+    const auto ret [[maybe_unused]] = m_socket->Connect(m_peer);
+    NS_LOG_DEBUG(this << " Connect() return value= " << ret << " GetErrNo= " << m_socket->GetErrno()
+                      << ".");
+
+    NS_ASSERT_MSG(m_socket, "Failed creating socket.");
+
+    SwitchToState(CONNECTING);
+
+    m_socket->SetConnectCallback(
+        MakeCallback(&ThreeGppHttpClient::ConnectionSucceededCallback, this),
+        MakeCallback(&ThreeGppHttpClient::ConnectionFailedCallback, this));
+    m_socket->SetCloseCallbacks(MakeCallback(&ThreeGppHttpClient::NormalCloseCallback, this),
+                                MakeCallback(&ThreeGppHttpClient::ErrorCloseCallback, this));
+    m_socket->SetRecvCallback(MakeCallback(&ThreeGppHttpClient::ReceivedDataCallback, this));
+    m_socket->SetAttribute("MaxSegLifetime", DoubleValue(0.02)); // 20 ms.
 } // end of `void OpenConnection ()`
 
 void
@@ -419,37 +442,35 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == CONNECTING || m_state == READING)
+    if (m_state != CONNECTING && m_state != READING)
     {
-        ThreeGppHttpHeader header;
-        header.SetContentLength(0); // Request does not need any content length.
-        header.SetContentType(ThreeGppHttpHeader::MAIN_OBJECT);
-        header.SetClientTs(Simulator::Now());
-
-        const uint32_t requestSize = m_httpVariables->GetRequestSize();
-        Ptr<Packet> packet = Create<Packet>(requestSize);
-        packet->AddHeader(header);
-        const uint32_t packetSize = packet->GetSize();
-        m_txMainObjectRequestTrace(packet);
-        m_txTrace(packet);
-        const int actualBytes = m_socket->Send(packet);
-        NS_LOG_DEBUG(this << " Send() packet " << packet << " of " << packet->GetSize() << " bytes,"
-                          << " return value= " << actualBytes << ".");
-        if (actualBytes != static_cast<int>(packetSize))
-        {
-            NS_LOG_ERROR(this << " Failed to send request for embedded object,"
-                              << " GetErrNo= " << m_socket->GetErrno() << ","
-                              << " waiting for another Tx opportunity.");
-        }
-        else
-        {
-            SwitchToState(EXPECTING_MAIN_OBJECT);
-            m_pageLoadStartTs = Simulator::Now(); // start counting page loading time
-        }
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for RequestMainObject().");
+    }
+
+    ThreeGppHttpHeader header;
+    header.SetContentLength(0); // Request does not need any content length.
+    header.SetContentType(ThreeGppHttpHeader::MAIN_OBJECT);
+    header.SetClientTs(Simulator::Now());
+
+    const auto requestSize = m_httpVariables->GetRequestSize();
+    auto packet = Create<Packet>(requestSize);
+    packet->AddHeader(header);
+    const auto packetSize = packet->GetSize();
+    m_txMainObjectRequestTrace(packet);
+    m_txTrace(packet);
+    const auto actualBytes = m_socket->Send(packet);
+    NS_LOG_DEBUG(this << " Send() packet " << packet << " of " << packet->GetSize() << " bytes,"
+                      << " return value= " << actualBytes << ".");
+    if (actualBytes != static_cast<int>(packetSize))
+    {
+        NS_LOG_ERROR(this << " Failed to send request for embedded object,"
+                          << " GetErrNo= " << m_socket->GetErrno() << ","
+                          << " waiting for another Tx opportunity.");
     }
     else
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for RequestMainObject().");
+        SwitchToState(EXPECTING_MAIN_OBJECT);
+        m_pageLoadStartTs = Simulator::Now(); // start counting page loading time
     }
 
 } // end of `void RequestMainObject ()`
@@ -459,47 +480,43 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == CONNECTING || m_state == PARSING_MAIN_OBJECT ||
-        m_state == EXPECTING_EMBEDDED_OBJECT)
+    if (m_state != CONNECTING && m_state != PARSING_MAIN_OBJECT &&
+        m_state != EXPECTING_EMBEDDED_OBJECT)
     {
-        if (m_embeddedObjectsToBeRequested > 0)
-        {
-            ThreeGppHttpHeader header;
-            header.SetContentLength(0); // Request does not need any content length.
-            header.SetContentType(ThreeGppHttpHeader::EMBEDDED_OBJECT);
-            header.SetClientTs(Simulator::Now());
-
-            const uint32_t requestSize = m_httpVariables->GetRequestSize();
-            Ptr<Packet> packet = Create<Packet>(requestSize);
-            packet->AddHeader(header);
-            const uint32_t packetSize = packet->GetSize();
-            m_txEmbeddedObjectRequestTrace(packet);
-            m_txTrace(packet);
-            const int actualBytes = m_socket->Send(packet);
-            NS_LOG_DEBUG(this << " Send() packet " << packet << " of " << packet->GetSize()
-                              << " bytes,"
-                              << " return value= " << actualBytes << ".");
-
-            if (actualBytes != static_cast<int>(packetSize))
-            {
-                NS_LOG_ERROR(this << " Failed to send request for embedded object,"
-                                  << " GetErrNo= " << m_socket->GetErrno() << ","
-                                  << " waiting for another Tx opportunity.");
-            }
-            else
-            {
-                m_embeddedObjectsToBeRequested--;
-                SwitchToState(EXPECTING_EMBEDDED_OBJECT);
-            }
-        }
-        else
-        {
-            NS_LOG_WARN(this << " No embedded object to be requested.");
-        }
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for RequestEmbeddedObject().");
+    }
+
+    if (m_embeddedObjectsToBeRequested == 0)
+    {
+        NS_LOG_WARN(this << " No embedded object to be requested.");
+        return;
+    }
+
+    ThreeGppHttpHeader header;
+    header.SetContentLength(0); // Request does not need any content length.
+    header.SetContentType(ThreeGppHttpHeader::EMBEDDED_OBJECT);
+    header.SetClientTs(Simulator::Now());
+
+    const auto requestSize = m_httpVariables->GetRequestSize();
+    auto packet = Create<Packet>(requestSize);
+    packet->AddHeader(header);
+    const auto packetSize = packet->GetSize();
+    m_txEmbeddedObjectRequestTrace(packet);
+    m_txTrace(packet);
+    const auto actualBytes = m_socket->Send(packet);
+    NS_LOG_DEBUG(this << " Send() packet " << packet << " of " << packet->GetSize() << " bytes,"
+                      << " return value= " << actualBytes << ".");
+
+    if (actualBytes != static_cast<int>(packetSize))
+    {
+        NS_LOG_ERROR(this << " Failed to send request for embedded object,"
+                          << " GetErrNo= " << m_socket->GetErrno() << ","
+                          << " waiting for another Tx opportunity.");
     }
     else
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for RequestEmbeddedObject().");
+        m_embeddedObjectsToBeRequested--;
+        SwitchToState(EXPECTING_EMBEDDED_OBJECT);
     }
 
 } // end of `void RequestEmbeddedObject ()`
@@ -509,59 +526,53 @@
 {
     NS_LOG_FUNCTION(this << packet << from);
 
-    if (m_state == EXPECTING_MAIN_OBJECT)
+    if (m_state != EXPECTING_MAIN_OBJECT)
+    {
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ReceiveMainObject().");
+    }
+
+    /*
+     * In the following call to Receive(), #m_objectBytesToBeReceived *will*
+     * be updated. #m_objectClientTs and #m_objectServerTs *may* be updated.
+     * ThreeGppHttpHeader will be removed from the packet, if it is the first
+     * packet of the object to be received; the header will be available in
+     * #m_constructedPacketHeader.
+     * #m_constructedPacket will also be updated.
+     */
+    Receive(packet);
+    m_rxMainObjectPacketTrace(packet);
+
+    if (m_objectBytesToBeReceived > 0)
     {
         /*
-         * In the following call to Receive(), #m_objectBytesToBeReceived *will*
-         * be updated. #m_objectClientTs and #m_objectServerTs *may* be updated.
-         * ThreeGppHttpHeader will be removed from the packet, if it is the first
-         * packet of the object to be received; the header will be available in
-         * #m_constructedPacketHeader.
-         * #m_constructedPacket will also be updated.
+         * There are more packets of this main object, so just stay still
+         * and wait until they arrive.
          */
-        Receive(packet);
-        m_rxMainObjectPacketTrace(packet);
-
-        if (m_objectBytesToBeReceived > 0)
-        {
-            /*
-             * There are more packets of this main object, so just stay still
-             * and wait until they arrive.
-             */
-            NS_LOG_INFO(this << " " << m_objectBytesToBeReceived << " byte(s)"
-                             << " remains from this chunk of main object.");
-        }
-        else
-        {
-            /*
-             * This is the last packet of this main object. Acknowledge the
-             * reception of a whole main object
-             */
-            NS_LOG_INFO(this << " Finished receiving a main object.");
-            m_rxMainObjectTrace(this, m_constructedPacket);
-
-            if (!m_objectServerTs.IsZero())
-            {
-                m_rxDelayTrace(Simulator::Now() - m_objectServerTs, from);
-                m_objectServerTs = MilliSeconds(0); // Reset back to zero.
-            }
-
-            if (!m_objectClientTs.IsZero())
-            {
-                m_rxRttTrace(Simulator::Now() - m_objectClientTs, from);
-                m_objectClientTs = MilliSeconds(0); // Reset back to zero.
-            }
+        NS_LOG_INFO(this << " " << m_objectBytesToBeReceived << " byte(s)"
+                         << " remains from this chunk of main object.");
+        return;
+    }
 
-            EnterParsingTime();
+    /*
+     * This is the last packet of this main object. Acknowledge the
+     * reception of a whole main object
+     */
+    NS_LOG_INFO(this << " Finished receiving a main object.");
+    m_rxMainObjectTrace(this, m_constructedPacket);
 
-        } // end of else of `if (m_objectBytesToBeReceived > 0)`
+    if (!m_objectServerTs.IsZero())
+    {
+        m_rxDelayTrace(Simulator::Now() - m_objectServerTs, from);
+        m_objectServerTs = MilliSeconds(0); // Reset back to zero.
+    }
 
-    } // end of `if (m_state == EXPECTING_MAIN_OBJECT)`
-    else
+    if (!m_objectClientTs.IsZero())
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ReceiveMainObject().");
+        m_rxRttTrace(Simulator::Now() - m_objectClientTs, from);
+        m_objectClientTs = MilliSeconds(0); // Reset back to zero.
     }
 
+    EnterParsingTime();
 } // end of `void ReceiveMainObject (Ptr<Packet> packet)`
 
 void
@@ -569,75 +580,69 @@
 {
     NS_LOG_FUNCTION(this << packet << from);
 
-    if (m_state == EXPECTING_EMBEDDED_OBJECT)
+    if (m_state != EXPECTING_EMBEDDED_OBJECT)
+    {
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ReceiveEmbeddedObject().");
+    }
+
+    /*
+     * In the following call to Receive(), #m_objectBytesToBeReceived *will*
+     * be updated. #m_objectClientTs and #m_objectServerTs *may* be updated.
+     * ThreeGppHttpHeader will be removed from the packet, if it is the first
+     * packet of the object to be received; the header will be available in
+     * #m_constructedPacket, which will also be updated.
+     */
+    Receive(packet);
+    m_rxEmbeddedObjectPacketTrace(packet);
+
+    if (m_objectBytesToBeReceived > 0)
     {
         /*
-         * In the following call to Receive(), #m_objectBytesToBeReceived *will*
-         * be updated. #m_objectClientTs and #m_objectServerTs *may* be updated.
-         * ThreeGppHttpHeader will be removed from the packet, if it is the first
-         * packet of the object to be received; the header will be available in
-         * #m_constructedPacket, which will also be updated.
+         * There are more packets of this embedded object, so just stay
+         * still and wait until they arrive.
          */
-        Receive(packet);
-        m_rxEmbeddedObjectPacketTrace(packet);
+        NS_LOG_INFO(this << " " << m_objectBytesToBeReceived << " byte(s)"
+                         << " remains from this chunk of embedded object");
+        return;
+    }
 
-        if (m_objectBytesToBeReceived > 0)
-        {
-            /*
-             * There are more packets of this embedded object, so just stay
-             * still and wait until they arrive.
-             */
-            NS_LOG_INFO(this << " " << m_objectBytesToBeReceived << " byte(s)"
-                             << " remains from this chunk of embedded object");
-        }
-        else
-        {
-            /*
-             * This is the last packet of this embedded object. Acknowledge
-             * the reception of a whole embedded object
-             */
-            NS_LOG_INFO(this << " Finished receiving an embedded object.");
-            m_rxEmbeddedObjectTrace(this, m_constructedPacket);
-
-            if (!m_objectServerTs.IsZero())
-            {
-                m_rxDelayTrace(Simulator::Now() - m_objectServerTs, from);
-                m_objectServerTs = MilliSeconds(0); // Reset back to zero.
-            }
-
-            if (!m_objectClientTs.IsZero())
-            {
-                m_rxRttTrace(Simulator::Now() - m_objectClientTs, from);
-                m_objectClientTs = MilliSeconds(0); // Reset back to zero.
-            }
-
-            if (m_embeddedObjectsToBeRequested > 0)
-            {
-                NS_LOG_INFO(this << " " << m_embeddedObjectsToBeRequested
-                                 << " more embedded object(s) to be requested.");
-                // Immediately request another using the existing connection.
-                m_eventRequestEmbeddedObject =
-                    Simulator::ScheduleNow(&ThreeGppHttpClient::RequestEmbeddedObject, this);
-            }
-            else
-            {
-                /*
-                 * There is no more embedded object, the web page has been
-                 * downloaded completely. Now is the time to read it.
-                 */
-                NS_LOG_INFO(this << " Finished receiving a web page.");
-                FinishReceivingPage(); // trigger callback for page loading time
-                EnterReadingTime();
-            }
+    /*
+     * This is the last packet of this embedded object. Acknowledge
+     * the reception of a whole embedded object
+     */
+    NS_LOG_INFO(this << " Finished receiving an embedded object.");
+    m_rxEmbeddedObjectTrace(this, m_constructedPacket);
 
-        } // end of else of `if (m_objectBytesToBeReceived > 0)`
+    if (!m_objectServerTs.IsZero())
+    {
+        m_rxDelayTrace(Simulator::Now() - m_objectServerTs, from);
+        m_objectServerTs = MilliSeconds(0); // Reset back to zero.
+    }
 
-    } // end of `if (m_state == EXPECTING_EMBEDDED_OBJECT)`
-    else
+    if (!m_objectClientTs.IsZero())
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ReceiveEmbeddedObject().");
+        m_rxRttTrace(Simulator::Now() - m_objectClientTs, from);
+        m_objectClientTs = MilliSeconds(0); // Reset back to zero.
     }
 
+    if (m_embeddedObjectsToBeRequested > 0)
+    {
+        NS_LOG_INFO(this << " " << m_embeddedObjectsToBeRequested
+                         << " more embedded object(s) to be requested.");
+        // Immediately request another using the existing connection.
+        m_eventRequestEmbeddedObject =
+            Simulator::ScheduleNow(&ThreeGppHttpClient::RequestEmbeddedObject, this);
+    }
+    else
+    {
+        /*
+         * There is no more embedded object, the web page has been
+         * downloaded completely. Now is the time to read it.
+         */
+        NS_LOG_INFO(this << " Finished receiving a web page.");
+        FinishReceivingPage(); // trigger callback for page loading time
+        EnterReadingTime();
+    }
 } // end of `void ReceiveEmbeddedObject (Ptr<Packet> packet)`
 
 void
@@ -667,7 +672,7 @@
         m_constructedPacket = packet->Copy();
         m_constructedPacket->AddHeader(httpHeader);
     }
-    uint32_t contentSize = packet->GetSize();
+    auto contentSize = packet->GetSize();
     m_numberBytesPage += contentSize; // increment counter of page size
 
     /* Note that the packet does not contain header at this point.
@@ -689,7 +694,7 @@
         m_objectBytesToBeReceived -= contentSize;
         if (!firstPacket)
         {
-            Ptr<Packet> packetCopy = packet->Copy();
+            auto packetCopy = packet->Copy();
             m_constructedPacket->AddAtEnd(packetCopy);
         }
     }
@@ -701,19 +706,17 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == EXPECTING_MAIN_OBJECT)
-    {
-        const Time parsingTime = m_httpVariables->GetParsingTime();
-        NS_LOG_INFO(this << " The parsing of this main object"
-                         << " will complete in " << parsingTime.As(Time::S) << ".");
-        m_eventParseMainObject =
-            Simulator::Schedule(parsingTime, &ThreeGppHttpClient::ParseMainObject, this);
-        SwitchToState(PARSING_MAIN_OBJECT);
-    }
-    else
+    if (m_state != EXPECTING_MAIN_OBJECT)
     {
         NS_FATAL_ERROR("Invalid state " << GetStateString() << " for EnterParsingTime().");
     }
+
+    const auto parsingTime = m_httpVariables->GetParsingTime();
+    NS_LOG_INFO(this << " The parsing of this main object will complete in "
+                     << parsingTime.As(Time::S) << ".");
+    m_eventParseMainObject =
+        Simulator::Schedule(parsingTime, &ThreeGppHttpClient::ParseMainObject, this);
+    SwitchToState(PARSING_MAIN_OBJECT);
 }
 
 void
@@ -721,37 +724,35 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_state == PARSING_MAIN_OBJECT)
+    if (m_state != PARSING_MAIN_OBJECT)
     {
-        m_embeddedObjectsToBeRequested = m_httpVariables->GetNumOfEmbeddedObjects();
-        // saving total number of embedded objects
-        m_numberEmbeddedObjectsRequested = m_embeddedObjectsToBeRequested;
-        NS_LOG_INFO(this << " Parsing has determined " << m_embeddedObjectsToBeRequested
-                         << " embedded object(s) in the main object.");
+        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ParseMainObject().");
+    }
 
-        if (m_embeddedObjectsToBeRequested > 0)
-        {
-            /*
-             * Immediately request the first embedded object using the
-             * existing connection.
-             */
-            m_eventRequestEmbeddedObject =
-                Simulator::ScheduleNow(&ThreeGppHttpClient::RequestEmbeddedObject, this);
-        }
-        else
-        {
-            /*
-             * There is no embedded object in the main object. So sit back and
-             * enjoy the plain web page.
-             */
-            NS_LOG_INFO(this << " Finished receiving a web page.");
-            FinishReceivingPage(); // trigger callback for page loading time
-            EnterReadingTime();
-        }
+    m_embeddedObjectsToBeRequested = m_httpVariables->GetNumOfEmbeddedObjects();
+    // saving total number of embedded objects
+    m_numberEmbeddedObjectsRequested = m_embeddedObjectsToBeRequested;
+    NS_LOG_INFO(this << " Parsing has determined " << m_embeddedObjectsToBeRequested
+                     << " embedded object(s) in the main object.");
+
+    if (m_embeddedObjectsToBeRequested > 0)
+    {
+        /*
+         * Immediately request the first embedded object using the
+         * existing connection.
+         */
+        m_eventRequestEmbeddedObject =
+            Simulator::ScheduleNow(&ThreeGppHttpClient::RequestEmbeddedObject, this);
     }
     else
     {
-        NS_FATAL_ERROR("Invalid state " << GetStateString() << " for ParseMainObject().");
+        /*
+         * There is no embedded object in the main object. So sit back and
+         * enjoy the plain web page.
+         */
+        NS_LOG_INFO(this << " Finished receiving a web page.");
+        FinishReceivingPage(); // trigger callback for page loading time
+        EnterReadingTime();
     }
 
 } // end of `void ParseMainObject ()`
